<?php
# seb2link v0.2
# inspiré du projet http://sebsauvage.net/wiki/doku.php?id=php:filehosting
# ainsi que de http://sebsauvage.net/wiki/doku.php?id=php:zerobin
# créé par PeaceCopathe

session_start();
$GLOBALS['subdir']='upload';//répertoire où seront uploader les fichiers
$GLOBALS['password']='motdepasse';//mot de passe pour uploader les fichiers
$GLOBALS['fileDB']='listFile.DB';// nom du fichier db
$GLOBALS['timeout']=1200;// temps de validité d'une session
$GLOBALS['listLink']=initialize();//création des répertoires et fichier nécessaire si besoin

verifSession();// on verifie si on cherche a se logger, et que le timeout n'est pas terminé.
delFileExpire();//supprime les fichier si expiré
afficheLink();// affiche le fichier
notLogged();//affiche la page login si pas loger
upload();//teste si envoie un fichier et generation d'un unique "lien"
formUpload();//affiche le formulaire d'envoi

function allIPs()
{
    $ip = $_SERVER["REMOTE_ADDR"];
    // Then we use more HTTP headers to prevent session hijacking from users behind the same proxy.
    if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) { $ip=$ip.'_'.$_SERVER['HTTP_X_FORWARDED_FOR']; }
    if (isset($_SERVER['HTTP_CLIENT_IP'])) { $ip=$ip.'_'.$_SERVER['HTTP_CLIENT_IP']; }
    return $ip;
}

function renderPage($page)
{
	echo '<!DOCTYPE html>
<html lang="fr">
<head>
<title>seb2Link</title>
<meta charset="UTF-8"/>
</head>
<body>'.$page.'</body></html>';
exit();
}

function stopFlood()
{
	$limitFlood=3;
	$timeFlood=20;
	$ip=allIPs();
	
	if(!file_exists('ipFlood.db'))
	{
	$listIp=array();
    file_put_contents('ipFlood.db',serialize($listIp));
	}
	
	$listIp=unserialize(file_get_contents('ipFlood.db'));
	if(array_key_exists($ip, $listIp)) 
	{
		if($listIp[$ip]['timer']<=time())
		{
			$listIp[$ip]['count']=0;
		}
		if($listIp[$ip]['count']>=$limitFlood)
		{
		$timeLast=$listIp[$ip]['timer']-time();
		$page='<h1>Stop Flood! veuillez attendre '.$timeLast.' secondes avant de recommencer. </h1>';
		renderPage($page);
		}
		$listIp[$ip]['count']++;
		$listIp[$ip]['timer']=time()+$timeFlood;
	}
	else
	{
		$listIp[$ip]['count']=1;
		
	}
	file_put_contents('ipFlood.db',serialize($listIp));
}

function initialize()
{
	if (!is_dir($GLOBALS['subdir'])) //creation des fichiers nécessaire si non existant
	{
    mkdir($GLOBALS['subdir'],0705); chmod($GLOBALS['subdir'],0705);
	$indexblank='<html><head><meta http-equiv="refresh" content="0;url='.$_SERVER["SCRIPT_NAME"].'"></head><body></body></html>';
	file_put_contents($GLOBALS['subdir'].'/index.html',$indexblank);
	}


	if(!file_exists($GLOBALS['subdir'].'/'.$GLOBALS['fileDB']))
	{
	$listLink=array();
    file_put_contents($GLOBALS['subdir'].'/'.$GLOBALS['fileDB'],serialize($listLink));
	}
	
	$listLink=unserialize(file_get_contents($GLOBALS['subdir'].'/'.$GLOBALS['fileDB']));
	
	return $listLink;
}

function verifSession()
{
	if(!empty($_POST['password']))
	{
		stopFlood();//methode anti brute force.
		if($_POST['password']==$GLOBALS['password'])
		{
			$_SESSION['logged']=time()+$GLOBALS['timeout'];
		}
	}

	if($_SESSION['logged']<time())
	{
		unset($_SESSION['logged']);
	}
}

function afficheLink()
{
	if(!empty($_GET['link'])) // affiche le fichier désigner par le lien
	{
		if(isset($GLOBALS['listLink'][$_GET['link']]))
		{
			$GLOBALS['listLink'][$_GET['link']]['nbredownload']++;
			file_put_contents($GLOBALS['subdir'].'/'.$GLOBALS['fileDB'],serialize($GLOBALS['listLink']));
			$file=$GLOBALS['subdir'].'/'.$GLOBALS['listLink'][$_GET['link']]['fileName'];
			if (file_exists($file))
			{
				header("Location: $file");
				exit();
			}

		}

			$page='<strong>Le fichier n\'existe pas.</strong>';
	        renderPage($page);
	}
}

function notLogged()
{
	if(empty($_SESSION['logged']))
	{
		$page='<form method="post" action="'.basename($_SERVER["SCRIPT_NAME"]).'" enctype="multipart/form-data">
	    mot de Passe: <input type="password" name="password"><br>
	    <input type="submit" value="Envoi">
		</form>';
		renderPage($page);
	}
	$_SESSION['logged']=time()+$GLOBALS['timeout'];
}

function delFileExpire()
{
	foreach ($GLOBALS['listLink'] as $key=>$value)
    {
		if(!is_file($GLOBALS['subdir'].'/'.$value['fileName']))
		{
			unset($GLOBALS['listLink'][$key]);
		}
		elseif (isset($value['expireDate']) && $value['expireDate']!=FALSE && $value['expireDate']<time())
            {
				unlink($GLOBALS['subdir'].'/'.$value['fileName']);
                unset($GLOBALS['listLink'][$key]);
            }

	}
	file_put_contents($GLOBALS['subdir'].'/'.$GLOBALS['fileDB'],serialize($GLOBALS['listLink']));
}

function upload()
{
	if(!empty($_FILES['filetoupload']))
	{
	sleep(3);
		if (!empty($_POST['linkExpiration']))
		{
		$expire=$_POST['linkExpiration'];
		if ($expire=='1min') $expireDate=time()+60;
		elseif ($expire=='10min') $expireDate=time()+10*60;
		elseif ($expire=='1hour') $expireDate=time()+60*60;
		elseif ($expire=='1day') $expireDate=time()+24*60*60;
		elseif ($expire=='1month') $expireDate=time()+30*24*60*60; // Well this is not *exactly* one month, it's 30 days.
		elseif ($expire=='1year') $expireDate=time()+365*24*60*60;
		elseif ($expire=='never') $expireDate=False;
		$file=$_FILES['filetoupload'];
		$filename = $GLOBALS['subdir'].'/'.basename( $file['name']);
	    if (file_exists($filename)) 
			{ 
			 $page='<h2>Le fichier existe déjà.</h2>';
			 renderPage($page); 
			 }
	    if(move_uploaded_file($file['tmp_name'], $filename))
	    {
	        $serverport=''; if ($_SERVER["SERVER_PORT"]!='80') { $serverport=':'.$_SERVER["SERVER_PORT"]; }
	        $id= uniqid();
	
	        $GLOBALS['listLink'][$id]=array('fileName'=>basename( $file['name']),'expireDate'=>$expireDate,'nbredownload'=>0);
	        file_put_contents($GLOBALS['subdir'].'/'.$GLOBALS['fileDB'],serialize($GLOBALS['listLink']));
	        $fileurl='http://'.$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"]).'/?link='.$id;
	        $page='Le fichier est maintenant accessible avec ce lien: <a href="'.$fileurl.'">'.$fileurl.'</a>';
	    }
	    else
		{
			$page= "<h1>Il y as eu une erreur durant l'upload!</h1>"; 
		}
	    $page.='<br><br><a href="'.basename($_SERVER["SCRIPT_NAME"]).'">retour</a>';
	    renderPage($page);
		}
	}
}

function formUpload()
{
$page='<form method="post" action="'.basename($_SERVER["SCRIPT_NAME"]).'" enctype="multipart/form-data">
    Fichier/image à uploader: <input type="file" name="filetoupload" size="60">
    <input type="hidden" name="MAX_FILE_SIZE" value="256000000"><br>
    Expire dans:<select id="linkExpiration" name="linkExpiration">
		<option value="1min">1 minutes</option>
        <option value="10min">10 minutes</option>
        <option value="1hour">1 heure</option>
        <option value="1day">1 jour</option>
        <option value="1month" selected="selected">1 mois</option>
        <option value="1year">1 an</option>
        <option value="never">Jamais</option>
     </select><br>
    <input type="submit" value="Envoi">

</form>';

$listFile='<div class="listLink"><h2>Listes des fichiers:</h2>';
foreach ($GLOBALS['listLink'] as $key=>$value)
    {
		$url= 'http://'.$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"]).'/?link='.$key;
		$listFile.= '<span>('
		.$GLOBALS['listLink'][$key]['nbredownload'].') expire le '.date('j/m/Y à H:i:s',$GLOBALS['listLink'][$key]['expireDate']).'-->  </span><a href="'.$url.'">'.$GLOBALS['listLink'][$key]['fileName'].'</a><br>';
	}
$listFile.='</div>';
$page.=$listFile;
renderPage($page);
}
?>
